;; Define function key sequences for Linux consoles

;;
;; To make buffer navigation easier, provide the opposite of bury-buffer
;;
(defun digup-buffer ()
  "Put BUFFER at the head of the list of all buffer.
This makes it the most likely candidate for `other-buffer' to return;
thus, the most likely buffer for C-x b to select by default."

  (interactive)
  (let ((buffer-list (nreverse (buffer-list)))
	buffer)
    (while (string-match "\\` "
			 (buffer-name
			  (prog1 (setq buffer (car buffer-list))
			    (setq buffer-list (cdr buffer-list))))))
    (switch-to-buffer buffer)))

;; Termcap or terminfo should set these.
;; (define-key function-key-map "\e[A" [up])
;; (define-key function-key-map "\e[B" [down])
;; (define-key function-key-map "\e[C" [right])
;; (define-key function-key-map "\e[D" [left])

(define-key function-key-map "\e[[A" [f1])
(define-key function-key-map "\e[[B" [f2])
(define-key function-key-map "\e[[C" [f3])
(define-key function-key-map "\e[[D" [f4])
(define-key function-key-map "\e[[E" [f5])
(define-key function-key-map "\e[17~" [f6])
(define-key function-key-map "\e[18~" [f7])
(define-key function-key-map "\e[19~" [f8])
(define-key function-key-map "\e[20~" [f9])
(define-key function-key-map "\e[21~" [f10])
(define-key function-key-map "\e[23~" [f11])
(define-key function-key-map "\e[24~" [f12])

(define-key function-key-map "\e[1~" [home])
(define-key function-key-map "\e[2~" [insert])
(define-key function-key-map "\e[3~" [delete])
(define-key function-key-map "\e[4~" [end])
(define-key function-key-map "\e[5~" [prior])
(define-key function-key-map "\e[6~" [next])

(global-set-key [home] 'beginning-of-line)
(global-set-key [end] 'end-of-line)
(global-set-key [delete] 'delete-char)
(global-set-key [f2] 'other-window)
(global-set-key [f3] 'split-window)
(global-set-key [f4] 'delete-other-windows)
(global-set-key [f5] 'beginning-of-buffer)
(global-set-key [f6] 'end-of-buffer)
(global-set-key [f7] 'bury-buffer)
(global-set-key [f8] 'digup-buffer)

